package com.ejie.ab39a.control;

import com.ejie.ab39a.service.ElementoService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import com.ejie.ab39a.model.Elemento;

/**
 * ElementoController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/elemento")

public class ElementoController {

	private static final Logger logger = LoggerFactory.getLogger(ElementoController.class);

	@Autowired
	private ElementoService elementoService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idElemento
	 *            Long id elemento
	 * @return Elemento Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idElemento}", method = RequestMethod.GET)
	public @ResponseBody Elemento get(@PathVariable Long idElemento) {
		Elemento elemento = new Elemento();
		elemento.setIdElemento(idElemento);
		elemento = this.elementoService.find(elemento);
		ElementoController.logger.info("[GET - findBy_PK] : Obtener Elemento por PK");
		return elemento;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterElemento
	 *            Elemento Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Elemento> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Elemento> getAll(@ModelAttribute Elemento filterElemento) {
		ElementoController.logger.info("[GET - find_ALL] : Obtener Elemento por filtro");
		return this.elementoService.findAll(filterElemento, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param elemento
	 *            Elemento Bean que contiene la informacion a modificar.
	 * @return Elemento Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody Elemento edit(@RequestBody Elemento elemento) {
		Elemento elementoAux = this.elementoService.update(elemento);
		ElementoController.logger.info("[PUT] : Elemento actualizado correctamente");
		return elementoAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param elemento
	 *            Elemento Bean que contiene la informacion con la que se va a
	 *            crear el nuevo registro.
	 * @return Elemento Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Elemento add(@RequestBody Elemento elemento) {
		Elemento elementoAux = this.elementoService.add(elemento);
		ElementoController.logger.info("[POST] : Elemento insertado correctamente");
		return elementoAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idElemento
	 *            Long Identificador del objeto que se desea eliminar.
	 * @return Elemento Bean eliminado.
	 */
	@RequestMapping(value = "/{idElemento}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Elemento remove(@PathVariable Long idElemento) {
		Elemento elemento = new Elemento();
		elemento.setIdElemento(idElemento);
		this.elementoService.remove(elemento);
		ElementoController.logger.info("[DELETE] : Elemento borrado correctamente");
		return elemento;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit() {
		ElementoController.logger.info("[GET - View] : elemento");
		return "elemento";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterElemento
	 *            Elemento Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<Elemento> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<Elemento> filter(@RequestJsonBody(param = "filter") Elemento filterElemento,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ElementoController.logger.info("[POST - filter] : Obtener Elementos");
		return this.elementoService.filter(filterElemento, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterElemento
	 *            Elemento Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") Elemento filterElemento,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ElementoController.logger.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Elementos");
		this.elementoService.removeMultiple(filterElemento, jqGridRequestDto, false);
		ElementoController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}
}
